package nuggeteer_settings;

$ENV{NUGGETEER_DATA_DIR} ||= 'data';

# Where to store learned model:
our $jdb = qq($ENV{NUGGETEER_DATA_DIR}/jdbs/official-2005.jdb); 

# What to learn:
our %training_settings = (
    jfiles => [ glob qq($ENV{NUGGETEER_DATA_DIR}/official-2005/*) ],
    answerkeys => [ qq($ENV{NUGGETEER_DATA_DIR}/official-2005.answers) ],

    # Empirically optimized with threshold: use a term's inverse document
    # frequency from the corpus rather than its local frequency:
    term_weighting => "idf",

    stopwords => "keep", # Empirically optimized with threshold: keep stopwords
    ngrams => 2, # Empirically optimized with threshold: use unigrams and bigrams
    stem => 0, # Empirically optimized with threshold: do not stem words
    beta => 3,

    # Responses indexed beyond this will not be considered, to avoid out of memory errors.
    max_judgement_rank => 500,

    lm_from_judgements => 0,  # Enabling this has been shown to be a bad idea.
    );

# How to use scores to decide whether a response contains a nugget:
our @decision_methods = ( 0.15 ); # A bare number is a fixed threshold
