package nuggeteer_settings;

# from nuggeteer documentation:
#                       thrshd n b stem weight stop      tau   rmse
# (definition) 2003   -  0.10  1 3  no  count  keep     0.898  0.074


$ENV{NUGGETEER_DATA_DIR} ||= 't/tiny-set/';

# where to store learned model:
our $jdb;
$jdb = qq(/tmp/nuggeteer-2003.db);

# what to learn:
our %training_settings;
%training_settings = (
    jfiles => [ glob qq(t/some-2003/LCC*) ],
    answerkeys => [ qq(t/official-2003.answers) ], 

    term_weighting => "count", # to be empirically optimized
    stopwords => "keep", # to be empirically optimized
    ngrams => 1, # to be empirically optimized
    stem => 0, # to be empirically optimized

    beta => 3, 

    # zero is infinity; this dataset is tiny and we want all of it:
    max_judgement_rank => 0,  

    lm_from_judgements => 0,
    );

# how to use scores to decide whether a response contains a nugget:
our @decision_methods;
@decision_methods = ( 0.10 ); # a bare number is a fixed threshold.
    
