#!/usr/bin/ruby

#require 'profile'
require File.dirname(__FILE__) + "/../data_set.rb"
require File.dirname(__FILE__) + "/../environment.rb"

Environment.execute do |options|

  dataset = DataSet.parse_from_stream(STDIN, :nugget)
  best_epsilon = dataset.best_epsilon

  gldataset = dataset.reallocate(:one_group)
  glthresh = gldataset.only_group.best_threshold(best_epsilon[0], best_epsilon[1])
  puts "GLOBAL\t#{glthresh}"

  dataset.data_groups.each do |group|
    if group.log10_prob_fixed_epsilon_marginal_threshold(best_epsilon[0], best_epsilon[1]) >
        group.log10_prob_fixed_threshold_fixed_epsilon(glthresh, best_epsilon[0], best_epsilon[1])
      nthresh = group.best_threshold(best_epsilon[0], best_epsilon[1])
      puts "NUGGET\t#{group.question_id}\t#{group.nugget_id}\t#{nthresh}"
      puts "nugget-level won at question #{group.question_id}, nugget #{group.nugget_id}."
    else
      puts "global won at question #{group.question_id}, nugget #{group.nugget_id}."
    end
  end

end
