require 'test/unit'
require File.dirname(__FILE__) + "/arithmetic.rb"

class ArithmeticTest < Test::Unit::TestCase

  def test_factorial
    assert_equal 120, 5.factorial
  end

  def test_choose
    assert_equal 10, 5.choose(3)
  end

  def test_choose_log10
    assert_in_delta 5.choose(3).estimated_log10, 5.choose_log10(3), 1E-07
  end

  def test_rational_times
    assert_equal 20, 4 * 5
    assert_equal 1/20, 1/4 * 1/5
    assert_equal 1/10, 1/5 * 1/2
    assert_equal 1/10, 1/5 * (1/2)
  end

#  def test_nearby_rational
#    assert_in_delta 0.1, 0.1.nearby_rational, 1E-07
#    assert_in_delta 2.71828E-100, 2.71828E-100.nearby_rational, 1E-107
#  end

  def test_logspace_sum
    assert_equal Math.log10(20), Arithmetic.logspace_sum([1, 1])
  end
end
