require 'test/unit'
require File.dirname(__FILE__) + "/data_point.rb"

class DataPointTest < Test::Unit::TestCase

  def test_line_parse

    assert_equal(DataPoint.new("2222", "1", 0.0416337474917464, :no),
                 DataPoint.parse_line("2222\t1\t0.0416337474917464\tno"))

    assert_equal(DataPoint.new("2222", "1", 0.0416337474917464e-07, :no),
                 DataPoint.parse_line("2222\t1\t0.0416337474917464e-07\tno"))

    assert_equal([DataPoint.new("1", "1", 0.5, :yes),
                  DataPoint.new("1", "1", 1.0, :yes),
                  DataPoint.new("1", "1", 0.4, :no),
                  DataPoint.new("1", "1", 0.2, :no)],
                 DataPoint.parse_line("1\t1\t0.5,1.0\t0.4,0.2"))

    assert_equal([DataPoint.new("1", "1", 5.0e-06, :yes),
                  DataPoint.new("1", "1", 1.0, :yes)],
                 DataPoint.parse_line("1\t1\t0.5e-05,1.0\t"))

    assert_equal([DataPoint.new("1", "1", 5.0e-06, :yes),
                  DataPoint.new("1", "1", 1.0, :no)],
                 DataPoint.parse_line("1\t1\t0.5e-05\t1.0"))

    assert_equal(DataPoint.parse_line("1\t1\t0.5e-05\t1.0"),
                 DataPoint.parse_line("1\t1\t0.5e-05\t1.0"))

    assert_equal([ DataPoint.new("qid03", "1", 0.2, :yes),
                   DataPoint.new("qid03", "1", 0.2, :yes),
                   DataPoint.new("qid03", "1", 0.2, :yes),
                   DataPoint.new("qid03", "1", 0.1, :no),
                   DataPoint.new("qid03", "1", 0.1, :no),
                   DataPoint.new("qid03", "1", 0.1, :no) ],
                 DataPoint.parse_line("qid03\t1\t0.2,0.2,0.2\t0.1,0.1,0.1"))

  end

end
