class DebugLine
  extend RegexParseable

  attr_reader :question_id, :nugget_id, :score, :response_str

  def self.regex
    /^#DEBUG\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9.]+)\s+(.+?)\s+NUGGET\s+([0-9]+)\s+(.+)$/
  end

  def initialize(qid, rank, nid, score, response_str, nid_again, desc)
    @question_id = qid
    @nugget_id = nid
    @score = score
    @response_str = response_str
    if @nugget_id != nid_again
      raise "Different specifications of the nugget id don't match."
    end
  end

  def print_data_point(system_run)
    judgement = system_run.response_by_string(@question_id, @response_str).judgement(@nugget_id)
    puts @question_id + "\t" + @nugget_id + "\t" + @score + "\t" + judgement.to_s
  end
end
