require 'test/unit'
require File.dirname(__FILE__) + "/judgement_request.rb"
require File.dirname(File.dirname(__FILE__)) + "/test_helper.rb"

class JudgementRequestTest < Test::Unit::TestCase

  include TestHelper

  def test_parse
    exp = [ JudgementRequest.new("q02", { "1" => 0.3 }, "foobar"),
            JudgementRequest.new("3001", { "2" => 0.45, "7" => 0.45 }, "baz"),
            JudgementRequest.new("3001", { "2" => 0.25, "7" => 0.25 }, "quux") ]
    assert_equal(exp,
                 JudgementRequest.parse_from_file(TRAINING_AND_JUDGEMENT_DATA))
  end

  def test_parse_live_data
    ans_hash = { "6" => 0.0454545454545455,
      "4" => 0.0228571428571429, "1" => 0, "3" => 0,
      "2" => 0.0300751879699248, "5" => 0.0357142857142857, "-1" => 0 }
    ans = JudgementRequest.new("1905", ans_hash,
                               "just to ensure we can get a second qid in here.")
    assert_equal(ans, JudgementRequest.parse_line("JUDGE_REQUEST	1905	6=>0.0454545454545455,4=>0.0228571428571429,1=>0,3=>0,2=>0.0300751879699248,5=>0.0357142857142857,-1=>0	just to ensure we can get a second qid in here."))

  end

  def test_print
    assert_equal("JUDGE_REQUEST\tq02\t1=>0.3\tfoobar",
                 JudgementRequest.new("q02", { "1" => 0.3 }, "foobar").to_s)

  end
end
