require 'test/unit'
require File.dirname(__FILE__) + "/test_helper.rb"
require File.dirname(__FILE__) + "/trec_f_measure.rb"

class TrecFMeasureTest < Test::Unit::TestCase

  include TestHelper

  def setup
    @good_measure = TrecFMeasure.new(:okay_count => 0, :vital_count => 4, :num_vital => 4, :length => 300, :beta => 3)
    @bad_measure = TrecFMeasure.new(:okay_count => 0, :vital_count => 0, :num_vital => 4, :length => 300, :beta => 3)
  end

  def test_smoke
    assert_equal 0, @good_measure.okay_count
    assert_equal 4, @good_measure.vital_count
    assert_equal 4, @good_measure.num_vital
    assert_equal 300, @good_measure.length
    assert_equal 3, @good_measure.beta
    assert_equal 400, @good_measure.allowance
    assert_equal 1, @good_measure.precision
    assert_equal 1, @good_measure.recall
    assert_equal 1, @good_measure.f_measure
  end

  def test_arithmetic
    average = @good_measure * 0.5 + @bad_measure * 0.5
    assert_equal 0, average.okay_count
    assert_equal 2, average.vital_count
    assert_equal 4, average.num_vital
    assert_equal 300, average.length
    assert_equal 3, average.beta
    assert_equal 200, average.allowance
    assert_equal 0.5, average.precision
    assert_equal 0.5, average.recall
    assert_equal 0.5, average.f_measure
  end

  def test_coerce
    assert_equal @good_measure, @good_measure.zero_measure + @good_measure
    assert_equal @good_measure, 0 + @good_measure
  end

end
