# -*- perl -*-

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Nuggeteer.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 15;

#########################

require "t/test_helper.pl";

my $pwd=`pwd`; chomp($pwd);
$ENV{PATH} .= ":$pwd";
my $n = $pwd;
$n =~ s|/Nuggeteer/.*?$|Nuggeteer|g;
$n = qq($n/src/nuggeteer.pl --debug);

my $ansfile = qq($pwd/t/official-2003.answers);
my $jdgdir = qq($pwd/t/some-2003);

my $errfile = qq(/tmp/t-nug.err);

my $t1 = "exact.out";
my $t2 = "bigrams-0.15-c.out";

# do the exact score test:
unlink qq(/tmp/test-nuggeteer-ek.jdb);
runok(qq($n --jdb /tmp/test-nuggeteer-ek.jdb --quiet --ensure-known $ansfile $jdgdir/* $jdgdir/MITCSAIL03.c),
      "t/output/$t1", $errfile, "exact");
check_genstats("t/output/$t1", 50, 0.3061, 0.0768, "exact");
same_output("t/golden/$t1", "t/output/$t1", "exact");


# do the approximate score test:
unlink qq(/tmp/test-nuggeteer-bg15.jdb);
runok(qq($n --jdb /tmp/test-nuggeteer-bg15.jdb --quiet --exclude --bigrams --threshold 0.15 $ansfile $jdgdir/* $jdgdir/MITCSAIL03.c),
      qq(t/output/$t2), $errfile, "approximate");
check_genstats("t/output/$t2", 50, 0.2685, 0.0769, "approximate");
same_output("t/golden/$t2", "t/output/$t2", "approximate");


unlink qq(/tmp/nuggeteer-2003.db);
runok(qq($n --quiet --settings migtest t/modified-csail03c-input),
      "t/output/test.out", $errfile, "modified input, guessing");
check_genstats("t/output/test.out", 50, 0.0054, 0.0109, "modified input, guessing");
same_output("t/golden/mig.out", "t/output/test.out", "modified input, guessing");

runok(qq($n --quiet --ensure-known $ansfile $jdgdir/LCC* t/modified-csail03c-input),
      "t/output/test.out", $errfile,
      "modified input with --ensure-known");
check_genstats("t/output/test.out", 50, 0, 0, "modified input with --ensure-known");

